# Define the kmod package name here.
%define kmod_name r8168

# If kversion isn't defined on the rpmbuild line, define it here.
%{!?kversion: %define kversion 2.6.18-128.el5}

Name:    %{kmod_name}-kmod
Version: 8.032.00
Release: 1%{?dist}
Group:   System Environment/Kernel
License: GPLv2
Summary: %{kmod_name} kernel module(s)
URL:     http://www.realtek.com.tw/

BuildRequires: redhat-rpm-config
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-build-%(%{__id_u} -n)
ExclusiveArch: i686 x86_64

# Sources.
Source0:  %{kmod_name}-%{version}.tar.bz2
Source5:  GPL-v2.0.txt
Source10: kmodtool-%{kmod_name}-el5.sh
Source20: ELRepo-Makefile-%{kmod_name}

# Patches.
Patch0: ELRepo-%{kmod_name}-%{version}.patch

# Define the variants for each architecture.
%define basevar ""
%ifarch i686
%define paevar PAE
%endif
%ifarch i686 x86_64
%define xenvar xen
%endif

# If kvariants isn't defined on the rpmbuild line, build all variants for this architecture.
%{!?kvariants: %define kvariants %{?basevar} %{?xenvar} %{?paevar}}

# Magic hidden here.
%{expand:%(sh %{SOURCE10} rpmtemplate_kmp %{kmod_name} %{kversion} %{kvariants})}

# Disable the building of the debug package(s).
%define debug_package %{nil}

# Define the filter.
%define __find_requires sh %{_builddir}/%{buildsubdir}/filter-requires.sh

%description
This package provides the %{kmod_name} kernel modules for Realtek RTL8168/RTL8111,
RTL8168B/RTL8111B, RTL8168C/RTL8111C, RTL8168CP/RTL8111CP, RTL8168D/RTL8111D,
RTL8168DP/RTL8111DP and RTL8168E/RTL8111E Gigabit Ethernet controllers with
the PCI-Express interface.
It is built to depend upon the specific ABI provided by a range of releases
of the same variant of the Linux kernel and not on any one specific build.

%prep
%setup -q -c -T -a 0
%patch0 -p1
%{__rm} -f %{kmod_name}-%{version}/src/Makefile*
%{__cp} -a %{SOURCE20} %{kmod_name}-%{version}/src/Makefile
for kvariant in %{kvariants} ; do
    %{__cp} -a %{kmod_name}-%{version}/src _kmod_build_$kvariant
done
echo "/usr/lib/rpm/redhat/find-requires | %{__sed} -e '/^ksym.*/d'" > filter-requires.sh
echo "override %{kmod_name} * weak-updates/%{kmod_name}" > kmod-%{kmod_name}.conf
echo "blacklist r8169" > blacklist-r8169.conf

%build
for kvariant in %{kvariants} ; do
    KSRC=%{_usrsrc}/kernels/%{kversion}${kvariant:+-$kvariant}-%{_target_cpu}
    %{__make} -C "${KSRC}" %{?_smp_mflags} modules M=$PWD/_kmod_build_$kvariant
done

%install
%{__rm} -rf %{buildroot}
export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=extra/%{kmod_name}
for kvariant in %{kvariants} ; do
    KSRC=%{_usrsrc}/kernels/%{kversion}${kvariant:+-$kvariant}-%{_target_cpu}
    %{__make} -C "${KSRC}" modules_install M=$PWD/_kmod_build_$kvariant
done
%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} -d %{buildroot}%{_sysconfdir}/modprobe.d/
%{__install} blacklist-r8169.conf %{buildroot}%{_sysconfdir}/modprobe.d/
%{__install} -d %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} %{SOURCE5} %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} %{kmod_name}-%{version}/README %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
# Set the module(s) to be executable, so that they will be stripped when packaged.
find %{buildroot} -type f -name \*.ko -exec %{__chmod} u+x \{\} \;

%clean
%{__rm} -rf %{buildroot}

%changelog
* Mon Sep 17 2012 Alan Bartlett <ajb@elrepo.org> - 8.032.00-1
- Updated to version 8.032.00

* Wed May 30 2012 Alan Bartlett <ajb@elrepo.org> - 8.031.00-1
- Updated to version 8.031.00

* Sat May 19 2012 Akemi Yagi <toracat@elrepo.org> - 8.030.00-1
- Updated to version 8.030.00

* Mon Apr 09 2012 Alan Bartlett <ajb@elrepo.org> - 8.029.00-1
- Updated to version 8.029.00

* Wed Mar 14 2012 Alan Bartlett <ajb@elrepo.org> - 8.028.00-2
- Reinstated the blacklist of the r8169 module.

* Thu Feb 09 2012 Alan Bartlett <ajb@elrepo.org> - 8.028.00-1
- Updated to version 8.028.00

* Fri Dec 30 2011 Alan Bartlett <ajb@elrepo.org> - 8.027.00-1
- Updated to version 8.027.00
- Removed the blacklist of the r8169 module.

* Mon May 29 2011 Alan Bartlett <ajb@elrepo.org> - 8.024.00-1
- Updated to version 8.024.00

* Mon Apr 25 2011 Alan Bartlett <ajb@elrepo.org> - 8.023.00-1
- Updated to version 8.023.00

* Sun Mar 20 2011 Alan Bartlett <ajb@elrepo.org> - 8.022.00-1
- Updated to version 8.022.00

* Wed Feb 09 2011 Alan Bartlett <ajb@elrepo.org> - 8.021.00-1
- Updated to version 8.021.00

* Fri Dec 10 2010 Alan Bartlett <ajb@elrepo.org> - 8.020.00_NAPI-1
- Updated to version 8.020.00_NAPI

* Thu Nov 04 2010 Alan Bartlett <ajb@elrepo.org> - 8.019.00_NAPI-2
- Updated package to current ELRepo Project standards.

* Mon Sep 13 2010 Alan Bartlett <ajb@elrepo.org> - 8.019.00_NAPI-1
- Updated to version 8.019.00_NAPI

* Thu Apr 08 2010 Alan Bartlett <ajb@elrepo.org> - 8.018.00_NAPI-1
- Updated to version 8.018.00_NAPI

* Thu Feb 04 2010 Alan Bartlett <ajb@elrepo.org> - 8.016.00_NAPI-1
- Updated to version 8.016.00_NAPI

* Sat Nov 28 2009 Alan Bartlett <ajb@elrepo.org> - 8.015.00_NAPI-1
- Updated to version 8.015.00_NAPI

* Wed Sep 09 2009 Alan Bartlett <ajb@elrepo.org> - 8.014.00_NAPI-1
- Updated to version 8.014.00_NAPI

* Sat May 30 2009 Alan Bartlett <ajb@elrepo.org> - 8.012.00_NAPI-1
- Updated to version 8.012.00_NAPI

* Wed Jan 28 2009 Alan Bartlett <ajb@elrepo.org> - 8.010.00_NAPI-1
- Updated to version 8.010.00_NAPI

* Mon Nov 17 2008 Alan Bartlett <ajb@elrepo.org>
- Initial el5 build of the kmod package.
